<?xml version="1.0" encoding="UTF-8"?>
<!-- 
	Converter for BIND XML data into psimi 1.0 expanded format.
	Written by Ahmet R. Ozturk 
	Emili Lab, University of Toronto / Canada
	e-mail: ahmetrasit@gmail.com
	August 23, 2006
	usage	(in linux shell): xsltproc <this xslt file>  <BIND XML file to be converted>  
-->


<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
<xsl:template match="/">

<!-- 	Following tests are done to see if there are protein-protein interactions in the file ( some files have just protein-dna interactions etc. )
 -->
<xsl:if test="BIND-Submit/BIND-Submit_interactions/BIND-Interaction-set/BIND-Interaction-set_interactions/BIND-Interaction/BIND-Interaction_a/BIND-object/BIND-object_id/BIND-object-type-id/BIND-object-type-id_protein">
<xsl:if test="BIND-Submit/BIND-Submit_interactions/BIND-Interaction-set/BIND-Interaction-set_interactions/BIND-Interaction/BIND-Interaction_b/BIND-object/BIND-object_id/BIND-object-type-id/BIND-object-type-id_protein">

<xsl:text>
</xsl:text>
<!-- 	initialization of the xml file, assigning entrySet as the root element and putting relevant information into it-->
<entrySet level="1" version="1" xmlns="net:sf:psidev:mi" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xsi:schemaLocation="net:sf:psidev:mi http://psidev.sourceforge.net/mi/xml/src/MIF.xsd">

<xsl:text>
</xsl:text>
	<!--	looking for each interaction in given location, and then checking to see if there are protein-protein interactions inside the entry  -->
	<xsl:for-each select="BIND-Submit/BIND-Submit_interactions/BIND-Interaction-set/BIND-Interaction-set_interactions/BIND-Interaction">
	<xsl:if test="BIND-Interaction_a/BIND-object/BIND-object_id/BIND-object-type-id/BIND-object-type-id_protein">
	<xsl:if test="BIND-Interaction_b/BIND-object/BIND-object_id/BIND-object-type-id/BIND-object-type-id_protein">

	<xsl:text>
	</xsl:text>
	<!--  	each entry has usually one interaction	-->
	<entry>
		<xsl:text>
		</xsl:text>
		<!--	source tag has information about the database-->
		<source>
			<xsl:text>
			</xsl:text>
			<names>
				<xsl:text>
				</xsl:text>
				<shortLabel>BIND</shortLabel>
				<xsl:text>
				</xsl:text>
			</names>
				<xsl:text>
				</xsl:text>
			<bibref>
				<xsl:text>
				</xsl:text>
				<xref>
					<xsl:text>
					</xsl:text>
					<primaryRef db="PubMed" id="12519993"/>
				<xsl:text>
				</xsl:text>
				</xref>
			<xsl:text>
			</xsl:text>
			</bibref>
		<xsl:text>
		</xsl:text>
		</source>
		<xsl:text>
		</xsl:text>	
		<!--  	this is where interactions are represented-->
		<interactionList>
			<xsl:text>
			</xsl:text>
			<!--  	following tag shows information related with each interaction-->
			<interaction>
				<xsl:text>
				</xsl:text>
				<names>
					<xsl:text>
					</xsl:text>
					<shortLabel>
						<xsl:text>
						</xsl:text>
						<!--  	following is the simple description of interaction-->
						<xsl:value-of select="BIND-Interaction_descr/BIND-descr/BIND-descr_simple-descr" />
					<xsl:text>
					</xsl:text>
					</shortLabel>
				<xsl:text>
				</xsl:text>
				</names>
				<xsl:text>
				</xsl:text>
				<!--  	following tag has information about the experimental setting, source publication etc.-->
				<experimentList>
					<!--  	following test is done to see if the tag given exists in BIND interaction data. Experimental data is stored under BIND-condition tag,
						if it does not exist; then we just get publications(pubmed ids) under specified tags and put it. Since we do not have interaction 
						detection method for the following case, we indicate that method is not specified (PSI MI:0686 stands for 'not specified')
					-->
					<xsl:if test="not(BIND-Interaction_descr/BIND-descr/BIND-descr_cond/BIND-condition-set/BIND-condition-set_conditions/BIND-condition)">
					<xsl:text>
					</xsl:text>
					<experimentDescription>
						<xsl:attribute name="id">
						<!--	we generate id attribute randomly. It should be unique to the experimentDescription	-->
							<xsl:value-of select="generate-id(.)"/>
						</xsl:attribute>
						<xsl:text>
						</xsl:text>
						<!-- 	Publication information is put under bibref/xref tag	-->
						<bibref>
							<xsl:text>
							</xsl:text>
							<xref>
							<!--	we first look at the following tag to find each publication information-->
							<xsl:for-each select="BIND-Interaction_source/BIND-pub-set/BIND-pub-set_pubs/BIND-pub-object">
								<xsl:choose>
									<!-- 	following test is done to be sure that we put the first pubmed id under primaryRef, 
										and if any, put remaining ones under secondaryRef tag	-->
									<xsl:when test="position()=1">
								<xsl:text>
								</xsl:text>
									<primaryRef db="PubMed">
										<xsl:attribute name="id">
											<!-- 	following tag is the place we look for PubMed id-->
											<xsl:value-of select="BIND-pub-object_pub/Pub/Pub_medline/Medline-entry/Medline-entry_cit/Cit-art/Cit-art_ids/ArticleIdSet/ArticleId/ArticleId_pubmed/PubMedId" />
										</xsl:attribute>
									</primaryRef>
									</xsl:when>
									<xsl:otherwise>
										<!-- 	following test is done to see if we encounter more than one publication-->
										<xsl:if test="BIND-pub-object_pub/Pub/Pub_medline/Medline-entry/Medline-entry_cit/Cit-art/Cit-art_ids/ArticleIdSet/ArticleId/ArticleId_pubmed/PubMedId">
								<xsl:text>
								</xsl:text>
									<secondaryRef db="PubMed">
                        	                                                <xsl:attribute name="id">
											<!-- 	put remaining PubMed ids under secondarRef	-->
                	                                                                <xsl:value-of select="BIND-pub-object_pub/Pub/Pub_medline/Medline-entry/Medline-entry_cit/Cit-art/Cit-art_ids/ArticleIdSet/ArticleId/ArticleId_pubmed/PubMedId" />
        	                                                                </xsl:attribute>
	                                                                </secondaryRef>
										</xsl:if>
									</xsl:otherwise>
								</xsl:choose>
							</xsl:for-each>
							<xsl:text>
							</xsl:text>
							</xref>
						<xsl:text>
						</xsl:text>
						</bibref>
						<!-- 	end of publication information	-->

						<xsl:text>
						</xsl:text>
						<!-- 	since we cannot get experiment information in this case, we just indicate that method is not specified	-->
						<interactionDetection>
							<xsl:text>
							</xsl:text>
							<names>
								<xsl:text>
								</xsl:text>
								<shortLabel>
									<xsl:text>
									</xsl:text>
									not specified
								<xsl:text>
								</xsl:text>
								</shortLabel>
								<xsl:text>
								</xsl:text>
								<fullName>
									<xsl:text>
									</xsl:text>
									not specified
								<xsl:text>
								</xsl:text>
								</fullName>
							<xsl:text>
							</xsl:text>
							</names>
							<xsl:text>
							</xsl:text>
							<xref>
								<xsl:text>
								</xsl:text>
								<primaryRef db="PSI-MI">
									<xsl:attribute name="id">
										<!-- 	following is the PSI MI term for not specified interaction detection method	-->
										MI:0686
									</xsl:attribute>
								</primaryRef>
							<xsl:text>
							</xsl:text>
							</xref>
						<xsl:text>
						</xsl:text>
						</interactionDetection>
						<!-- 	end of interactionDetection tag-->

					<xsl:text>
					</xsl:text>
					</experimentDescription>
					</xsl:if>
					<!-- 	end of the test. end of the case that no information was found in data and PubMed ids are populated from elsewhere	-->

					<!--	following is the case that experimental information resides inside the data and we are parsing each experimental condition	-->
					<xsl:for-each select="BIND-Interaction_descr/BIND-descr/BIND-descr_cond/BIND-condition-set/BIND-condition-set_conditions/BIND-condition">
					<xsl:text>
					</xsl:text>
					
					<!--	beginning of experimental description that has information about the experimental setting of the identification of the interaction	-->
					<experimentDescription>
						<xsl:attribute name="id">
							<!-- 	id attribute is generated randomly that should be unique for each experimentDescription	-->
							<xsl:value-of select="generate-id(.)"/>
						</xsl:attribute>
						<xsl:text>
						</xsl:text>

						<!-- Publication information is put under bibref/xref tag-->
						<bibref>
							<xsl:text>
							</xsl:text>
							<xref>
							<!--	following test is done to see if PubMed id exists in its proper place	-->
							<xsl:if test="BIND-condition_source/BIND-pub-set/BIND-pub-set_pubs/BIND-pub-object/BIND-pub-object_pub/Pub/Pub_pmid/PubMedId">
								<!-- 	each time following tag is found, it is parsed to find a PubMed id	-->
								<xsl:for-each select="BIND-condition_source/BIND-pub-set/BIND-pub-set_pubs/BIND-pub-object">
								<xsl:choose>
									<!--	follwing test is done to be sure that first encountered PubMed id will be put under primaryRef tag,
										and if any other ids are found, they will be put under secondaryRef tag	-->
									<xsl:when test="position()=1">
								<xsl:text>
								</xsl:text>
									<primaryRef db="PubMed">
										<xsl:attribute name="id">
											<!-- 	following tag is the place where PubMed ids are stored in a typical BIND record	-->
											<xsl:value-of select="BIND-pub-object_pub/Pub/Pub_pmid/PubMedId" />
										</xsl:attribute>
									</primaryRef>
									</xsl:when>
									<xsl:otherwise>
										<xsl:if test="BIND-pub-object_pub/Pub/Pub_pmid/PubMedId">
								<xsl:text>
								</xsl:text>
									<!-- 	if more than one PubMed id is found, remaining ones are put under the following tag	-->
									<secondaryRef db="PubMed">
                        	                                                <xsl:attribute name="id">
                	                                                                <xsl:value-of select="BIND-pub-object_pub/Pub/Pub_pmid/PubMedId" />
        	                                                                </xsl:attribute>
	                                                                </secondaryRef>
										</xsl:if>
									</xsl:otherwise>
								</xsl:choose>
								</xsl:for-each>
							<xsl:text>
							</xsl:text>
							</xsl:if>
							<!-- 	end of checking to see if there are any PubMed ids	-->

							<!-- 	following is the case that no PubMed ids are found under specified tag,
								There can be either Pub_muid tags that store PubMed ids. If even it is not found,
								in this case, '-1' is put as an indicatior of the lack of a PubMed id	-->
							<xsl:if test="not(BIND-condition_source/BIND-pub-set/BIND-pub-set_pubs/BIND-pub-object/BIND-pub-object_pub/Pub/Pub_pmid/PubMedId)">
								

								<xsl:if test="BIND-condition_source/BIND-pub-set/BIND-pub-set_pubs/BIND-pub-object/BIND-pub-object_pub/Pub/Pub_muid">
									<!-- 	each time following tag is found, it is parsed to find a PubMed id	-->
									<xsl:for-each select="BIND-condition_source/BIND-pub-set/BIND-pub-set_pubs/BIND-pub-object">
									<xsl:choose>
										<!--	follwing test is done to be sure that first encountered PubMed id will be put under primaryRef tag,
											and if any other ids are found, they will be put under secondaryRef tag	-->
										<xsl:when test="position()=1">
								<xsl:text>
								</xsl:text>
										<primaryRef db="PubMed">
											<xsl:attribute name="id">
												<!-- 	following tag is the place where PubMed ids are stored in a typical BIND record	-->
												<xsl:value-of select="BIND-pub-object_pub/Pub/Pub_muid" />
											</xsl:attribute>
										</primaryRef>
										</xsl:when>
										<xsl:otherwise>
											<xsl:if test="BIND-pub-object_pub/Pub/Pub_muid">
								<xsl:text>
								</xsl:text>
											<!-- 	if more than one PubMed id is found, remaining ones are put under the following tag	-->
											<secondaryRef db="PubMed">
                		        	                                                <xsl:attribute name="id">
                			                                                                <xsl:value-of select="BIND-pub-object_pub/Pub/Pub_muid" />
        	                		                                                </xsl:attribute>
		                        	                                        </secondaryRef>
											</xsl:if>
										</xsl:otherwise>
									</xsl:choose>
									</xsl:for-each>
							<xsl:text>
							</xsl:text>
								</xsl:if>
							<!-- 	end of checking to see if there are any PubMed ids under Pub_muid tags	-->

								<!--	If we cannot find PubMed ids under Pub_muid or Pub_pmid tags, then assign -1	-->

								<xsl:if test="not(BIND-condition_source/BIND-pub-set/BIND-pub-set_pubs/BIND-pub-object/BIND-pub-object_pub/Pub/Pub_muid)">
									<primaryRef db="PubMed" id="-1" />
								</xsl:if>
							</xsl:if>
							<!-- 	end of the test. end of the case that no PubMed ids are found under specified tag	-->
							</xref>
						<xsl:text>
						</xsl:text>
						</bibref>
						<!-- 	end of bibref, where publication information was put	-->

						<xsl:text>
						</xsl:text>
						
						<!-- 	following tag is the place for interaction detection information	-->
						<interactionDetection>
							<xsl:text>
							</xsl:text>
							<!-- 	short and full name of the interaction detection method id put under the following tag	-->
							<names>
								<xsl:text>
								</xsl:text>
								<shortLabel>
								<xsl:text>
								</xsl:text>
									<!-- 	shortLabel information is parsed from the specified tag	-->
									<xsl:value-of select="BIND-condition_system/BIND-experimental-system/@value"/>
								<xsl:text>
								</xsl:text>
								</shortLabel>
								<xsl:text>
								</xsl:text>
								<fullName>
									<xsl:text>
									</xsl:text>
									<!-- 	fullName information is parsed from the specified tag	-->
									<xsl:value-of select="BIND-condition_descr"/>
								<xsl:text>
								</xsl:text>
								</fullName>
							<xsl:text>
							</xsl:text>
							</names>
							<!-- 	end of interaction detection method name information	-->

							<xsl:text>
							</xsl:text>

							<!-- 	following tag is the place for putting xref of interaction detection method. ids are given according to
								a controlled vocabulary of BIND	-->
							<xref>
								<xsl:text>
								</xsl:text>
								<primaryRef db="BIND">
									<xsl:attribute name="id">
										<!--	detection method id is parsed from the specified tag	-->
										<xsl:value-of select="BIND-condition_system/BIND-experimental-system"/>
									</xsl:attribute>
								</primaryRef>
							<xsl:text>
							</xsl:text>
							</xref>
						<xsl:text>
						</xsl:text>
						</interactionDetection>
						<!-- 	end of interactionDetection information	-->

					<xsl:text>
					</xsl:text>
					</experimentDescription>
					<!-- 	end of experimentDescription information where experimental settings related with the interaction were put-->

					</xsl:for-each>
					<!-- 	end of the for-each statement that have looked at all experimental condition informations-->
					
				<xsl:text>
				</xsl:text>
				</experimentList>
				<!-- 	end of experimentList where experiment descriptions were put under	-->

				<xsl:text>
				</xsl:text>
			
				<!-- 	following tag has the list of interacting proteins. In each participantList, there are only two proteinParticipants since BIND represents 
					interactions in pairs, as protein_a and protein_b-->
				<participantList>
					<xsl:text>
					</xsl:text>
					<!-- 	following tag has the information about the first interacting protein	-->
					<proteinParticipant>
						<xsl:text>
						</xsl:text>
						<proteinInteractor>
							<xsl:attribute name="id">
								<!-- 	id attribute is generated randomly which should be unique. It does not need to be specific to  each interactor 
									since cPath deals with the names/ids	-->
								<xsl:value-of select="generate-id(BIND-Interaction_a)"/>
							</xsl:attribute>
							<xsl:text>
							</xsl:text>

							<!-- 	following tag has information about the first interacting protein	-->
							<names>
								<xsl:text>
								</xsl:text>
								<shortLabel>
									<xsl:text>
									</xsl:text>
									<!-- 	short label of the interactor is parsed from the specified tag	-->
									<xsl:value-of select="BIND-Interaction_a/BIND-object/BIND-object_short-label"/>
								<xsl:text>
								</xsl:text>
								</shortLabel>
								<xsl:text>
								</xsl:text>
								<fullName>
									<xsl:text>
									</xsl:text>
									<!-- 	full name of the interactor is parsed from the specified tag	-->
									<xsl:value-of select="BIND-Interaction_a/BIND-object/BIND-object_descr"/>
								<xsl:text>
								</xsl:text>
								</fullName>
							<xsl:text>
							</xsl:text>
							</names>
							<!-- 	end of name information of the first interactor	-->

							<xsl:text>
							</xsl:text>

							<!-- 	following tag has information of the xref of the first interactor	-->
							<xref>
								<xsl:text>
								</xsl:text>
								
								<!-- 	following tests are done to get relevant information as much as possible	-->
								<!-- 	when/otherwise statements under choose statement is like if/else statement	-->
								<xsl:choose>
									<!-- 	if the short label of the intractor is given as 'Unknown', then assign 0329 which indicates unknown proteins	-->
									<xsl:when test="starts-with(BIND-Interaction_a/BIND-object/BIND-object_short-label,'Unknown')">
										<primaryRef db="PSIMI" id="0329"/>
									</xsl:when>
									<!-- 	else if the short label of the intractor is given as 'NULL', then assign 0329 which indicates unknown proteins	-->
									<xsl:when test="starts-with(BIND-Interaction_a/BIND-object/BIND-object_short-label,'NULL')">
										<primaryRef db="PSIMI" id="0329"/>
									</xsl:when>
									<!-- 	else if interactor has Geneinfo id different than zero, then assign it	-->
									<xsl:when test="BIND-Interaction_a/BIND-object/BIND-object_id/BIND-object-type-id/BIND-object-type-id_protein/BIND-id/BIND-id_gi/Geninfo-id != 0">
										<primaryRef db="Entrez GI">
											<xsl:attribute name="id">
												<!-- 	following is the place where Geneinfo id exists	-->
												<xsl:value-of select="BIND-Interaction_a/BIND-object/BIND-object_id/BIND-object-type-id/BIND-object-type-id_protein/BIND-id/BIND-id_gi/Geninfo-id"/>
											</xsl:attribute>
										</primaryRef>
									</xsl:when>
									<!-- 	else if interactor has strp different than zero, then assign it	-->
									<!-- 	this is the place where additional database/id information about the interactor is put	-->
									<xsl:when test="BIND-Interaction_a/BIND-object/BIND-object_extref/BIND-other-db/BIND-other-db_strp != 0">
										<primaryRef>
											<xsl:attribute name="db">
												<!-- 	following is the place where the name of database is specified	-->
												<xsl:value-of select="BIND-Interaction_a/BIND-object/BIND-object_extref/BIND-other-db/BIND-other-db_dbname"/>
											</xsl:attribute>
											<xsl:attribute name="id">
												<!-- 	following is the place where the id of interactor is specified	-->
												<xsl:value-of select="BIND-Interaction_a/BIND-object/BIND-object_extref/BIND-other-db/BIND-other-db_strp"/>
											</xsl:attribute>
										</primaryRef>
									</xsl:when>
									<!-- 	else if interactor has intp different than zero, then assign it	-->
									<!--    this is the place where additional database/id information about the interactor is put  -->
                                                                        <xsl:when test="BIND-Interaction_a/BIND-object/BIND-object_extref/BIND-other-db/BIND-other-db_intp != 0">
                                                                                <primaryRef>
                                                                                        <xsl:attribute name="db">
												<!-- 	following is the place where the name of database is specified	-->
                                                                                                <xsl:value-of select="BIND-Interaction_a/BIND-object/BIND-object_extref/BIND-other-db/BIND-other-db_dbname"/>
                                                                                        </xsl:attribute>
                                                                                        <xsl:attribute name="id">
												<!-- 	following is the place where the id of interactor is specified	-->
                                                                                                <xsl:value-of select="BIND-Interaction_a/BIND-object/BIND-object_extref/BIND-other-db/BIND-other-db_intp"/>
                                                                                        </xsl:attribute>
                                                                                </primaryRef>
                                                                        </xsl:when>
									<!-- 	else if interactor has a domain id different than zero, then assign it	-->
									<!-- 	domain id represents Entrez Gene id	-->
									<xsl:when test="BIND-Interaction_a/BIND-object/BIND-object_id/BIND-object-type-id/BIND-object-type-id_protein/BIND-id/BIND-id_di/Domain-id != 0">
										<primaryRef db="Entrez Gene">
											<xsl:attribute name="id">
												<!-- 	following is the place where the domain id of interactor is specified	-->
											<xsl:value-of select="BIND-Interaction_a/BIND-object/BIND-object_id/BIND-object-type-id/BIND-object-type-id_protein/BIND-id/BIND-id_di/Domain-id"/>
											</xsl:attribute>
										</primaryRef>
									</xsl:when>
									<!-- 	else, nothing appropriate is found, which hopefully does not happen, then assign 0329 which indicates unspecified protein -->
                                                                        <xsl:otherwise>
										<primaryRef db="PSIMI" id="0329"/>
                                                                        </xsl:otherwise>
								</xsl:choose>
								<!-- 	end of tests that were used to get xref information about the first interactor	-->
							<xsl:text>
							</xsl:text>
							</xref>
							<!-- 	end of xref information that were used to give additional information about the first interactor	-->

							<xsl:text>
							</xsl:text>

							<!-- 	following tag has information about the source organism of the first interactor	-->
							<organism>
								<xsl:attribute name="ncbiTaxId">
									<!-- 	taxonomy id is parsed from the specified tag	-->
									<xsl:if test="BIND-Interaction_a/BIND-object/BIND-object_origin/BIND-object-origin/BIND-object-origin_org/BioSource/BioSource_org/Org-ref/Org-ref_db/Dbtag/Dbtag_tag/Object-id/Object-id_id">
										<xsl:value-of select="BIND-Interaction_a/BIND-object/BIND-object_origin/BIND-object-origin/BIND-object-origin_org/BioSource/BioSource_org/Org-ref/Org-ref_db/Dbtag/Dbtag_tag/Object-id/Object-id_id"/>
									</xsl:if>
									<!--    if no taxonomy id is found, then assume that it is unidentified ( for artificial peptides )     -->
									<xsl:if test="not(BIND-Interaction_a/BIND-object/BIND-object_origin/BIND-object-origin/BIND-object-origin_org/BioSource/BioSource_org/Org-ref/Org-ref_db/Dbtag/Dbtag_tag/Object-id/Object-id_id)">
											<xsl:text>32644</xsl:text>
									</xsl:if>
								</xsl:attribute>
								<xsl:text>
								</xsl:text>
								<!-- 	following tag has the name of organism	-->
								<names>
									<xsl:text>
									</xsl:text>
									<shortLabel>
										<!-- 	short label of the organism is parsed from the following tag	-->
										<xsl:if test="BIND-Interaction_a/BIND-object/BIND-object_origin/BIND-object-origin/BIND-object-origin_org/BioSource/BioSource_org/Org-ref/Org-ref_taxname">
											<xsl:value-of select="BIND-Interaction_a/BIND-object/BIND-object_origin/BIND-object-origin/BIND-object-origin_org/BioSource/BioSource_org/Org-ref/Org-ref_taxname"/>
										</xsl:if>
										<!--    if no taxonomy name is found, then assume that it is unidentified ( for artificial peptides )   -->
                                                                                <xsl:if test="not(BIND-Interaction_a/BIND-object/BIND-object_origin/BIND-object-origin/BIND-object-origin_org/BioSource/BioSource_org/Org-ref/Org-ref_taxname)">
											<xsl:text>unidentified</xsl:text>
                                                                                </xsl:if>
									</shortLabel>
									<fullName>
										<!-- 	short label of the organism is parsed from the following tag	-->
										<xsl:if test="BIND-Interaction_a/BIND-object/BIND-object_origin/BIND-object-origin/BIND-object-origin_org/BioSource/BioSource_org/Org-ref/Org-ref_taxname">
											<xsl:value-of select="BIND-Interaction_a/BIND-object/BIND-object_origin/BIND-object-origin/BIND-object-origin_org/BioSource/BioSource_org/Org-ref/Org-ref_taxname"/>
										</xsl:if>
										<!--    if no taxonomy name is found, then assume that it is unidentified ( for artificial peptides )   -->
                                                                                <xsl:if test="not(BIND-Interaction_a/BIND-object/BIND-object_origin/BIND-object-origin/BIND-object-origin_org/BioSource/BioSource_org/Org-ref/Org-ref_taxname)">
											<xsl:text>unidentified</xsl:text>
                                                                                </xsl:if>
									</fullName>
								<xsl:text>
								</xsl:text>	
								</names>
							<xsl:text>
							</xsl:text>
							</organism>
							<!-- 	end of the organism information	-->

						<xsl:text>
						</xsl:text>
						</proteinInteractor>
						<!-- 	end of the first interactor information	-->
					<xsl:text>
					</xsl:text>
					</proteinParticipant>
					<!-- 	end of the first protein participant-->

					<xsl:text>
					</xsl:text>

					<!-- 	following tag has the information about the second interacting protein	-->
					<proteinParticipant>
						<xsl:text>
						</xsl:text>
						<proteinInteractor>
							<xsl:attribute name="id">
                                                                <!--    id attribute is generated randomly which should be unique. It does not need to be specific to  each interactor
                                                                        since cPath deals with the names/ids    -->
                                                        	<xsl:value-of select="generate-id(BIND-Interaction_b)"/>
							</xsl:attribute>
							<xsl:text>
							</xsl:text>
                                                       
							<!--    following tag has information about the second interacting protein       -->
							<names>
								<xsl:text>
								</xsl:text>
								<shortLabel>
									<xsl:text>
									</xsl:text>
									<!--    short label of the interactor is parsed from the specified tag  -->
									<xsl:value-of select="BIND-Interaction_b/BIND-object/BIND-object_short-label"/>
								<xsl:text>
								</xsl:text>
								</shortLabel>
								<xsl:text>
								</xsl:text>
								<fullName>
									<xsl:text>
									</xsl:text>
									<!--    full name of the interactor is parsed from the specified tag    -->
									<xsl:value-of select="BIND-Interaction_b/BIND-object/BIND-object_descr"/>
								<xsl:text>
								</xsl:text>
								</fullName>
							<xsl:text>
							</xsl:text>
							</names>
							<!--    end of name information of the second interactor -->

							<xsl:text>
							</xsl:text>

							<!--    following tag has information of the xref of the second interactor	-->
							<xref>
								<xsl:text>
								</xsl:text>
								
								<!--    following tests are done to get relevant information as much as possible        -->
                                                                <!--    when/otherwise statements under choose statement is like if/else statement      -->
                                                                <xsl:choose>
									<!--    if the short label of the intractor is given as 'Unknown', then assign 0329 which indicates unknown proteins    -->
                                                                        <xsl:when test="starts-with(BIND-Interaction_b/BIND-object/BIND-object_short-label,'Unknown')">
                                                                                <primaryRef db="PSIMI" id="0329"/>
                                                                        </xsl:when>
									<!--    else if the short label of the intractor is given as 'NULL', then assign 0329 which indicates unknown proteins  -->
                                                                        <xsl:when test="starts-with(BIND-Interaction_b/BIND-object/BIND-object_short-label,'NULL')">
                                                                                <primaryRef db="PSIMI" id="0329"/>
                                                                        </xsl:when>
									<!--    else if interactor has Geneinfo id different than zero, then assign it  -->
                                                                        <xsl:when test="BIND-Interaction_b/BIND-object/BIND-object_id/BIND-object-type-id/BIND-object-type-id_protein/BIND-id/BIND-id_gi/Geninfo-id != 0">
                                                                                <primaryRef db="Entrez GI">
                                                                                        <xsl:attribute name="id">
                                                                                                <xsl:value-of select="BIND-Interaction_b/BIND-object/BIND-object_id/BIND-object-type-id/BIND-object-type-id_protein/BIND-id/BIND-id_gi/Geninfo-id"/>
                                                                                        </xsl:attribute>
                                                                                </primaryRef>
                                                                        </xsl:when>
									<!--    else if interactor has strp different than zero, then assign it -->
                                                                        <!--    this is the place where additional database/id information about the interactor is put  -->
                                                                        <xsl:when test="BIND-Interaction_b/BIND-object/BIND-object_extref/BIND-other-db/BIND-other-db_strp != 0">
                                                                                <primaryRef>
                                                                                        <xsl:attribute name="db">
                                                                                                <xsl:value-of select="BIND-Interaction_b/BIND-object/BIND-object_extref/BIND-other-db/BIND-other-db_dbname"/>
                                                                                        </xsl:attribute>
                                                                                        <xsl:attribute name="id">
                                                                                                <xsl:value-of select="BIND-Interaction_b/BIND-object/BIND-object_extref/BIND-other-db/BIND-other-db_strp"/>
                                                                                        </xsl:attribute>
                                                                                </primaryRef>
                                                                        </xsl:when>
									<!--    else if interactor has intp different than zero, then assign it -->
									<!--    this is the place where additional database/id information about the interactor is put  -->
                                                                        <xsl:when test="BIND-Interaction_b/BIND-object/BIND-object_extref/BIND-other-db/BIND-other-db_intp != 0">
                                                                                <primaryRef>
                                                                                        <xsl:attribute name="db">
                                                                                                <xsl:value-of select="BIND-Interaction_b/BIND-object/BIND-object_extref/BIND-other-db/BIND-other-db_dbname"/>
                                                                                        </xsl:attribute>
                                                                                        <xsl:attribute name="id">
                                                                                                <xsl:value-of select="BIND-Interaction_b/BIND-object/BIND-object_extref/BIND-other-db/BIND-other-db_intp"/>
                                                                                        </xsl:attribute>
                                                                                </primaryRef>
                                                                        </xsl:when>
									<!--    else if interactor has a domain id different than zero, then assign it  -->
                                                                        <!--    domain id represents Entrez Gene id     -->
                                                                        <xsl:when test="BIND-Interaction_b/BIND-object/BIND-object_id/BIND-object-type-id/BIND-object-type-id_protein/BIND-id/BIND-id_di/Domain-id != 0">
                                                                                <primaryRef db="Entrez Gene">
                                                                                        <xsl:attribute name="id">
                                                                                <xsl:value-of select="BIND-Interaction_b/BIND-object/BIND-object_id/BIND-object-type-id/BIND-object-type-id_protein/BIND-id/BIND-id_di/Domain-id"/>
                                                                                        </xsl:attribute>
                                                                                </primaryRef>
                                                                        </xsl:when>
									<!--    else, nothing appropriate is found, which hopefully does not happen, then assign 0329 which indicates unspecified protein -->
                                                                        <xsl:otherwise>
                                                                                <primaryRef db="PSIMI" id="0329"/>
                                                                        </xsl:otherwise>
                                                                </xsl:choose>
								<!--    end of tests that were used to get xref information about the second interactor       -->

							<xsl:text>
							</xsl:text>
							</xref>
							<!--    end of xref information that were used to give additional information about the second interactor     -->

							<xsl:text>
							</xsl:text>

							<!--    following tag has information about the source organism of the second interactor -->
							<organism>
							
							<!--    taxonomy id is parsed from the specified tag    -->
							<xsl:if test="BIND-Interaction_b/BIND-object/BIND-object_origin/BIND-object-origin/BIND-object-origin_org/BioSource/BioSource_org/Org-ref/Org-ref_db/Dbtag/Dbtag_tag/Object-id/Object-id_id">
								<xsl:attribute name="ncbiTaxId">
										<xsl:value-of select="BIND-Interaction_b/BIND-object/BIND-object_origin/BIND-object-origin/BIND-object-origin_org/BioSource/BioSource_org/Org-ref/Org-ref_db/Dbtag/Dbtag_tag/Object-id/Object-id_id"/>
								</xsl:attribute>
							</xsl:if>
							<!--    if no taxonomy id is found, then assume that it is unidentified ( for artificial peptides )     -->
                                                        <xsl:if test="not(BIND-Interaction_b/BIND-object/BIND-object_origin/BIND-object-origin/BIND-object-origin_org/BioSource/BioSource_org/Org-ref/Org-ref_db/Dbtag/Dbtag_tag/Object-id/Object-id_id)">
								<xsl:attribute name="ncbiTaxId">
									<xsl:text>32644</xsl:text>
								</xsl:attribute>
							</xsl:if>
								<xsl:text>
								</xsl:text>
								<!--    following tag has the name of organism  -->
								<names>
									<xsl:text>
									</xsl:text>
									<shortLabel>
										<!--    short label of the organism is parsed from the following tag    -->
										<xsl:if test="BIND-Interaction_b/BIND-object/BIND-object_origin/BIND-object-origin/BIND-object-origin_org/BioSource/BioSource_org/Org-ref/Org-ref_taxname">
											<xsl:value-of select="BIND-Interaction_b/BIND-object/BIND-object_origin/BIND-object-origin/BIND-object-origin_org/BioSource/BioSource_org/Org-ref/Org-ref_taxname"/>
										</xsl:if>
										<!--    if no taxonomy name is found, then assume that it is unidentified ( for artificial peptides )   -->
                                                                                <xsl:if test="not(BIND-Interaction_b/BIND-object/BIND-object_origin/BIND-object-origin/BIND-object-origin_org/BioSource/BioSource_org/Org-ref/Org-ref_taxname)">
                                                                                       <xsl:text>unidentified</xsl:text>
                                                                                </xsl:if>
									</shortLabel>
									<fullName>
										<!-- 	short label of the organism is parsed from the following tag	-->
										<xsl:if test="BIND-Interaction_b/BIND-object/BIND-object_origin/BIND-object-origin/BIND-object-origin_org/BioSource/BioSource_org/Org-ref/Org-ref_taxname">
											<xsl:value-of select="BIND-Interaction_b/BIND-object/BIND-object_origin/BIND-object-origin/BIND-object-origin_org/BioSource/BioSource_org/Org-ref/Org-ref_taxname"/>
										</xsl:if>
										<!--    if no taxonomy name is found, then assume that it is unidentified ( for artificial peptides )   -->
                                                                                <xsl:if test="not(BIND-Interaction_b/BIND-object/BIND-object_origin/BIND-object-origin/BIND-object-origin_org/BioSource/BioSource_org/Org-ref/Org-ref_taxname)">
											<xsl:text>unidentified</xsl:text>
                                                                                </xsl:if>
									</fullName>
								<xsl:text>
								</xsl:text>
								</names>
							<xsl:text>	
							</xsl:text>
							</organism>
							<!--    end of the organism information -->

						<xsl:text>
						</xsl:text>
						</proteinInteractor>
						<!--    end of the second interactor information -->
					<xsl:text>
					</xsl:text>
					</proteinParticipant>
					<!--    end of the second protein participant-->

				<xsl:text>
				</xsl:text>
				</participantList>
				<!-- 	end of the participant list where information about the interactors are given	-->
				
				<xsl:text>
				</xsl:text>

				<!-- 	following tag has information about the BIND interaction id	-->
				<xref>
					<xsl:text>
					</xsl:text>
					<primaryRef db="BIND">
						<xsl:attribute name="id">
							<!-- 	BIND interaction id is parsed from the specified tag	-->
							<xsl:value-of select="BIND-Interaction_iid/Interaction-id" />
						</xsl:attribute>
					</primaryRef>
				<xsl:text>
				</xsl:text>
				</xref>
				<!-- 	end of BIND interaction id information-->

			<xsl:text>
			</xsl:text>
			</interaction>
			<!-- 	end of interaction information-->

		<xsl:text>
		</xsl:text>
		</interactionList>
		<!-- 	end of the interaction list where interaction information were put	-->

	<xsl:text>
	</xsl:text>
	</entry>
	<!-- 	end of the entry	-->

	<xsl:text>
	</xsl:text>

	</xsl:if>
	</xsl:if>
	</xsl:for-each>
	<!--	end of looking for each interaction and checking to see if there are protein-protein interactions inside the entry  -->
	
<xsl:text>
</xsl:text>
</entrySet>
<!-- 	end of root element 'entrySet'	-->

</xsl:if>
</xsl:if>
<!-- 	end of the statements to check if there are protein-protein interactions inside the file	-->

</xsl:template>
</xsl:stylesheet>
<!-- 	end of the xslt document, hopefully well-commented	-->
