########
#	Ahmet R. Ozturk
# 	Emili Lab, University of Toronto, Canada
#	August 28, 2006
#	e-mail: ahmetrasit@gmail.com
########
#	You need to specify the name of the source BIND XML file to be splitted. Resulting file
#	will have a trailer string to indicate the part of the file. In some cases,
#	due to the structure of the source BIND XML file, it might not work properly.


use strict;


my $file = shift @ARGV;

open (RD, $file) or die "Error : $!\n";
while (<RD>){
	last if (/<BIND-Interaction-set_interactions>/);
}

$/ = "\n\n\n";

my $file_count;
my $count;
while(<RD>){
	if ($count % 4000 == 0){
		unless ($count == 0){
			print WR '</BIND-Interaction-set_interactions>' . "\n";
			print WR '</BIND-Interaction-set>' . "\n";
			print WR '</BIND-Submit_interactions>' . "\n";
			print WR '</BIND-Submit>';
			close WR;
		}
		$file_count++;
		open(WR, ">$file.part$file_count") or print "\n\nError : $!\n\n\n";
		
		print WR '<?xml version="1.0" encoding="UTF-8"?>' . "\n";
		print WR '<BIND-Submit>' . "\n";
		print WR '<BIND-Submit_interactions>' . "\n";
		print WR '<BIND-Interaction-set>' . "\n";
		print WR '<BIND-Interaction-set_interactions>' . "\n";

		print "$file.part$file_count is created\n"
	}
	print WR  "$_\n\n\n";
	print "$count\n";
	$count++;
	#last if ($count > 4000);

}

unless($count % 4000 == 1){
	print WR '</BIND-Interaction-set_interactions>' . "\n";
	print WR '</BIND-Interaction-set>' . "\n";
	print WR '</BIND-Submit_interactions>' . "\n";
	print WR '</BIND-Submit>';
}
print "\n\nTotal exp: $count\nTotal files: $file_count\nIt took ".(time-$^T)." seconds.\n";
